import React from "react";

export default class CustomEditor extends React.Component {

    txtRef = React.createRef();

    state = {
        text: ""
    };

    //region Cell editing interface, required functions

    // Should return the value to be applied when editing finishes
    getValue() {
        return this.state.text;
    }

    // Current cell value + context, set when editing starts. Use it to populate your editor
    setValue(value, cellEditorContext) {
        this.setState({ text: value });
    }

    // Invalid editors are note allowed to close (unless grid is so configured).
    // Implement this function to handle validation of your editor.
    isValid() {
        return true;
    }

    // Called when editing starts, to set focus at the desired place in your editor
    focus() {
        this.txtRef.current && this.txtRef.current.focus();
    }

    //endregion

    render() {
        return <input ref={this.txtRef} type="text" style={{ width: "100%" }} value={this.state.text || ""} onChange={(e) => { this.setState({ text: e.target.value }); }} />
    }
}
